<template>
  <div id="header-container">
    <div id="tempheader">
      <img :src="require('../assets/logo.png')" alt="Logo" width="209" height="125">
      <!-- <img :src="require('../assets/logo2.png')" alt='Logo' width=240 height=106/> -->
      <div id="descriptor">
        <h1>ДОСТАВКА ПИЦЦЫ. МОСКВА</h1>
        <h1>При покупке двух любых пицц – третья&nbsp;в&nbsp;подарок!</h1>
      </div>
      <div id="phone">
        <h2>НАГАТИНСКАЯ</h2>
        <a class="phone-number" href="tel:+74957921700">+7 (495) 792-17-00</a>
        <br>
        <br>
        <h2>ЮГО-ЗАПАДНАЯ</h2>
        <a class="phone-number" href="tel:+74959685644">+7 (495) 968-56-44</a>
        <br>
        <br>
        <div id="social-links">
          <!-- <a href="https://vk.com/mapizza" target="_blank">
                        <img class="icon" :src='require("../assets/svg_vk.svg")' />
          </a>-->
          <a href="https://www.facebook.com/motsnapizza/" target="_blank">
            <img class="icon" :src="require('../assets/svg_facebook.svg')">
          </a>
          <a href="https://www.instagram.com/mapizza.ru/" target="_blank">
            <img class="icon" :src="require('../assets/svg_instagram.svg')">
          </a>
        </div>
      </div>
    </div>

    <div id="header">
      <div id="header-menu">
        <app-header-link
          url="catalog"
          text="МЕНЮ"
          v-scroll-to="{el: '#categ-common-pizza', offset: longOffset}"
        />
        <app-header-link url="contacts" text="КОНТАКТЫ"/>
      </div>
      <div id="cart-link" v-if="this.$store.state.ordered.length > 0">
        <app-header-link
          url="order"
          :text="`В корзине ${getOrderItemsCount} шт. на ${getOrderSum} ₽`"
        />
      </div>
    </div>
  </div>
</template>

<script>
import HeaderLink from "./HeaderLink";
import { mapGetters, mapMutations } from "vuex";
export default {
  data() {
    return {
      shortOffset: -50,
      longOffset: -200
    };
  },

  components: {
    "app-header-link": HeaderLink
  },

  created() {
    window.addEventListener("scroll", this.handleScroll);
  },
  mounted() {
    this.handleScroll(null);
  },
  updated() {
    this.handleScroll(null);
  },

  beforeDestroy() {
    window.removeEventListener("scroll", this.handleScroll);
  },

  methods: {
    ...mapMutations(["filterByCategory"]),
    handleScroll(event) {
      const scrolled = window.pageYOffset || document.documentElement.scrollTop;
      const tempheader = document.getElementById("tempheader");
      if (scrolled > 3 * tempheader.offsetHeight) return;
      const menu = document.getElementById("header");
      const catalog = document.getElementById("body-container");
      catalog.style.marginTop =
        tempheader.offsetHeight + menu.offsetHeight + "px";
      this.shortOffset = 0 - menu.offsetHeight;
      this.longOffset = 0 - menu.offsetHeight - tempheader.offsetHeight;

      let header = document.getElementById("header-container");
      if (scrolled > tempheader.offsetHeight) {
        header.style.top = 0 - tempheader.offsetHeight + "px";
      } else {
        header.style.top = 0 - scrolled + "px";
      }
    }
  },

  computed: {
    ...mapGetters([
      "getOrderItemsCount",
      "getOrderSum",
      "getCategories",
      "isMobile"
    ])
  }
};
</script>

<style scoped>
.icon {
  width: 20px;
  height: 20px;
}
#social-links {
  margin-top: 10px;
  text-align: center;
}
#social-links a {
  margin-left: 5px;
  margin-right: 5px;
}

h1 {
  font-size: 1.2em;
  padding-left: 20px;
  padding-right: 20px;
  padding-top: 5px;
}

h2 {
  font-size: 1.2em;
  text-align: center;
}

h3 {
  font-size: 1.5em;
}

#descriptor {
  min-width: 250px;
}

#phone {
  text-align: right;
  flex: 1;
}

.phone-number {
  font-size: 1.2em;
  text-align: center;
  color: #de601b;
}

#header-container {
  position: fixed;
  top: 0;
  width: 100vw;
  max-width: 1060px;
}

#tempheader {
  display: flex;
  flex-flow: column nowrap;
  width: 100%;
  align-items: center;
  background-color: white;
}

#tempheader div {
  margin-top: 10px;
  margin-bottom: 10px;
}

#header {
  display: flex;
  width: 100%;
  background-color: white;
  flex-flow: column nowrap;
  justify-content: space-between;
  align-items: center;
  box-shadow: 0px 5px 5px -4px #777;
  padding-bottom: 10px;
  padding-top: 10px;
}

#header-menu {
  display: flex;
  flex-flow: row nowrap;
}

#cart-link {
  text-align: right;
  margin-bottom: 15px;
}

#cart-link a {
  border: none;
  padding: 7px;
  border-radius: 10px;
  background-color: #f0712c;
  color: white;
  width: 250px;
  transition: all 0.1s ease;
}

#cart-link a:hover {
  background-color: #de601b;
}
</style>



